<script setup>
import { ref } from "vue";
import axios from "axios";

// Объект для работы с telegram
const tg = window.Telegram.WebApp;

// Если использовать обычные переменные, а не ссылки,
// то при изменении значения перерисовки не будет
// К ссылкам обращаемся через поле value в блоке script и напрямую в блоке template
const login = ref("");
const code = ref("");
const maskedPhoneNumber = ref("");
const error = ref("");

const mode = ref("login");

const onGetCodeBtnClick = () => {
  error.value = "";
  axios
    .post("https://682c-80-251-112-250.ngrok-free.app/api/v1/Client/auth", {
      //Если tg.initDataUnsafe?.user?.id не определен используем 0 для локального тестирования
      userId: tg.initDataUnsafe?.user?.id ?? 0,
      login: login.value,
    })
    .then((response) => {
      // Тут находится код, который выполняется после того как получен ответ от запроса выше
      // response - объект ответа
      // Для дебага можно посмотреть в консоли браузера добавив
      console.log(response);

      mode.value = "code";
      maskedPhoneNumber.value = response.data.maskedPhoneNumber;
    })
    .catch((er) => {
      error.value =
        er.response?.data?.error?.description ??
        "Что-то пошло не так. Попробуйте снова";
    });
};

const onSubmitCodeBtnClick = () => {
  error.value = "";
  axios
    .post(
      "https://682c-80-251-112-250.ngrok-free.app/api/v1/Client/auth/confirm",
      {
        //Если tg.initDataUnsafe?.user?.id не определен используем 0 для локального тестирования
        userId: tg.initDataUnsafe?.user?.id ?? 0,
        confirmationCode: code.value,
      }
    )
    .then(() => {
      mode.value = "success";
    })
    .catch((er) => {
      error.value =
        er.response?.data?.error?.description ??
        "Что-то пошло не так. Попробуйте снова";
    });
};

const onChangeLogin = () => {
  mode.value = "login";
  login.value = "";
  error.value = "";
};
</script>

<template>
  <div class="login-page-container">
    <!-- В зависимости от значения mode рисуем разные экраны -->
    <template v-if="mode === 'login'">
      <input
        v-model="login"
        placeholder="Введите логин"
        class="login-page-input"
      />
      <button
        @click="onGetCodeBtnClick"
        :disabled="!login"
        class="login-page-button"
      >
        Далее
      </button>
    </template>
    <template v-else-if="mode === 'code'">
      <div class="login-page-doc-info">
        <div>Код отправлен в СМС на номер {{ maskedPhoneNumber }}</div>
        <button @click="onChangeLogin" class="login-page-change-login-btn">
          Сменить пользователя
        </button>
      </div>
      <input
        v-model="code"
        placeholder="Введите код"
        class="login-page-input"
      />
      <button @click="onSubmitCodeBtnClick" class="login-page-button">
        Далее
      </button>
    </template>
    <template v-else><span class="login-page-success">Авторизация прошла успешно</span></template>
    <div v-if="error" class="login-page-error">Ошибка {{ error }}</div>
  </div>
</template>

<style scoped>
.login-page-container {
  display: flex;
  flex-direction: column;
  gap: 16px;
  width: 100%;
}

.login-page-input {
  height: 56px;
  font-size: 20px;
  line-height: 24px;
  padding: 0 15px;
  border: none;
  border-bottom: 1px solid rgba(0, 0, 0, 0.54);
}

.login-page-input:focus {
  outline: none !important;
  border-bottom: 3px solid rgba(0, 0, 0, 0.54);
}

.login-page-button {
  height: 56px;
  font-size: 20px;
  line-height: 24px;
  background-color: #ffb800;
  border-radius: 100px;
  border: none;
}

.login-page-change-login-btn {
  background-color: inherit;
  border: 1px solid rgba(52, 64, 121, 0.2);
  font-size: 12px;
  line-height: 16px;
  border-radius: 100px;
  padding: 6px;
}

.login-page-doc-info {
  display: flex;
  gap: 8px;
  margin: 20px 0;
}

.login-page-error {
  color: red;
  font-weight: bold;
}

.login-page-success {
  font-size: 20px;
  line-height: 24px;
}
</style>
